package cn.com.infosec.jce.provider;

import cn.com.infosec.jce.exception.ExtCertPathBuilderException;
import cn.com.infosec.util.Selector;
import cn.com.infosec.x509.ExtendedPKIXBuilderParameters;
import cn.com.infosec.x509.X509CertStoreSelector;
import java.security.InvalidAlgorithmParameterException;
import java.security.cert.CertPathBuilderException;
import java.security.cert.CertPathBuilderResult;
import java.security.cert.CertPathBuilderSpi;
import java.security.cert.CertPathParameters;
import java.security.cert.PKIXBuilderParameters;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

public class PKIXCertPathBuilderSpi extends CertPathBuilderSpi {
   private Exception certPathException;

   public CertPathBuilderResult engineBuild(CertPathParameters params) {
      if (!(params instanceof PKIXBuilderParameters) && !(params instanceof ExtendedPKIXBuilderParameters)) {
         throw new InvalidAlgorithmParameterException("Parameters must be an instance of " + PKIXBuilderParameters.class.getName() + " or " + ExtendedPKIXBuilderParameters.class.getName() + ".");
      } else {
         ExtendedPKIXBuilderParameters params1;
         if (params instanceof ExtendedPKIXBuilderParameters) {
            params1 = (ExtendedPKIXBuilderParameters)params;
         } else {
            params1 = (ExtendedPKIXBuilderParameters)ExtendedPKIXBuilderParameters.getInstance((PKIXBuilderParameters)params);
         }

         ArrayList var2;
         var2 = new ArrayList.<init>();
         Selector var3;
         if ((var3 = params1.getTargetConstraints()) instanceof X509CertStoreSelector) {
            Collection var4;
            Collection var12;
            label66: {
               AnnotatedException var10000;
               label75: {
                  boolean var10001;
                  try {
                     var12 = CertPathValidatorUtilities.findCertificates((X509CertStoreSelector)var3, params1.getStores());
                  } catch (AnnotatedException var6) {
                     var10000 = var6;
                     var10001 = false;
                     break label75;
                  }

                  Collection var13 = var4 = var12;

                  try {
                     var13.addAll(CertPathValidatorUtilities.findCertificates((X509CertStoreSelector)var3, params1.getCertStores()));
                     break label66;
                  } catch (AnnotatedException var5) {
                     var10000 = var5;
                     var10001 = false;
                  }
               }

               AnnotatedException var7 = var10000;
               throw new ExtCertPathBuilderException("Error finding target certificate.", var7);
            }

            if (var12.isEmpty()) {
               throw new CertPathBuilderException("No certificate found matching targetContraints.");
            } else {
               CertPathBuilderResult var10 = null;

               for(Iterator var11 = var4.iterator(); var11.hasNext() && var10 == null; var10 = this.build((X509Certificate)var11.next(), params1, var2)) {
               }

               Exception params2;
               if (var10 == null && (params2 = this.certPathException) != null) {
                  if (params2 instanceof AnnotatedException) {
                     throw new CertPathBuilderException(this.certPathException.getMessage(), this.certPathException.getCause());
                  } else {
                     throw new CertPathBuilderException("Possible certificate chain could not be validated.", this.certPathException);
                  }
               } else if (var10 == null && this.certPathException == null) {
                  throw new CertPathBuilderException("Unable to find certificate chain.");
               } else {
                  return var10;
               }
            }
         } else {
            throw new CertPathBuilderException("TargetConstraints must be an instance of " + X509CertStoreSelector.class.getName() + " for " + this.getClass().getName() + " class.");
         }
      }
   }

   protected CertPathBuilderResult build(X509Certificate param1, ExtendedPKIXBuilderParameters param2, List param3) {
      // $FF: Couldn't be decompiled
   }
}
